diff ../mk/file.c ./file.c
4a5,8
> /*
>  * layers.c needs more information than just mtime about each file.
>  * let's try not to stat the file for every bit of metadata.
>  */
11a16,19
> 	/* cache metadata in the symbol table */
> 	symlook(name, S_TIME, (void*)sbuf.mtime);
> 	symlook(strdup(name), S_LAYERS,
> 		(void*)newlayer((Fsinst){sbuf.type, sbuf.dev}));
19d26
< 	long t;
30,36c37
< 
< 	t = mtime(name);
< 	if(t == 0)
< 		return 0;
< 
< 	symlook(name, S_TIME, (void*)t);		/* install time in cache */
< 	return t;
---
> 	return mtime(name);

diff ../mk/fns.h ./fns.h
36a37
> int	islowerfs(Node *targ, Node *prereq);
46a48
> Layering *newlayer(Fsinst fs);

diff ../mk/graph.c ./graph.c
164a165
> 	Symtab *sym;
169a171,174
> 	node->type = node->dev = 0;
> 	sym = symlook(name, S_LAYERS, 0);	/* mtime() should've set it */
> 	if (sym)
> 		node->Fsinst = ((Layering *)sym->value)->Fsinst;

Only in .: layer.c

diff ../mk/mk.c ./mk.c
199a200,205
> /*
>  * is target node out of date with respect to prerequisite arc->n?
>  *
>  * we may be building in a union directory, so ignore targets
>  * at a lower level than the highest-level prerequisite.
>  */
222a229,230
> 		return 1;
> 	else  if (islowerfs(node, arc->n))

diff ../mk/mk.h ./mk.h
74a75,87
> /* a file server instance id */
> typedef struct Fsinst
> {
> 	ushort	type;			/* server type */
> 	ushort	dev;			/* server subtype */
> } Fsinst;
> /* layers of a union directory */
> typedef struct Layering
> {
> 	Fsinst;
> 	struct Layering *lower;		/* or `after' */
> } Layering;
> 
79a93
> 	Fsinst;				/* for union dir.s */
138a153
> 	S_LAYERS,	/* file -> Layering (Fsinst) */

diff ../mk/mkfile ./mkfile
3c3
< TARG=mk
---
> TARG=ovmk
10a11
> 	layer.$O\
